#include <stdio.h>
#include <stdlib.h>
#include "group_based_partition.h"
#include <string.h>
#include "fupermod/fupermod.h"

/* FUNCTION DECLERATION
   int smallest_element_index(int* work_array,mm_col_i_group *col_group, int max_j,int current_y, int* smallest_index, int* smallest_value);
   int measure( mm_col_i_group *col_group,int total_proc, int max_j);
   int uniq_group(int* group_id_local,int max_j);
   void push_height (int* array,int *top_h,int value);
   void push_group_id (int* array,int *top_g,int value);
   void init(int *top);
 */
/* MAIN PROGRAM FOR TEST
   int main(int argc, char** argv) {
   mm_col_i_distrib* dist;
   dist =(mm_col_i_distrib*)calloc(sizeof(mm_col_i_distrib),1);
   mm_col_i_group col_group[16];


//	int count = sizeof(col_group) / sizeof(struct mm_col_i_group);
//	col_group = malloc (sizeof(struct mm_col_i_group*) * count);
//tmp = (mm_col_i_group*)malloc(sizeof(mm_col_i_group) * 16);

// FOR CHECK
col_group[0].d.y=0;col_group[0].d.h=11; col_group[0].d.i=0;col_group[0].d.j=0; col_group[0].group_id=0;
col_group[1].d.y=11;col_group[1].d.h=10; col_group[1].d.i=1;col_group[1].d.j=0; col_group[1].group_id=0;
col_group[2].d.y=21;col_group[2].d.h=11;col_group[2].d.i=2;col_group[2].d.j=0; col_group[2].group_id=0;
col_group[3].d.y=0;col_group[3].d.h=12; col_group[3].d.i=0;col_group[3].d.j=1; col_group[3].group_id=0;
col_group[4].d.y=12;col_group[4].d.h=7; col_group[4].d.i=1;col_group[4].d.j=1; col_group[4].group_id=3;
col_group[5].d.y=19;col_group[5].d.h=6; col_group[5].d.i=2;col_group[5].d.j=1; col_group[5].group_id=3;
col_group[6].d.y=25;col_group[6].d.h=7; col_group[6].d.i=3;col_group[6].d.j=1; col_group[6].group_id=1;
col_group[7].d.y=0;col_group[7].d.h=8; col_group[7].d.i=0;col_group[7].d.j=2 ; col_group[7].group_id=1;
col_group[8].d.y=8;col_group[8].d.h=8; col_group[8].d.i=1;col_group[8].d.j=2; col_group[8].group_id=1; 
col_group[9].d.y=16;col_group[9].d.h=8; col_group[9].d.i=2;col_group[9].d.j=2; col_group[9].group_id=3;
col_group[10].d.y=24;col_group[10].d.h=8;col_group[10].d.i=3;col_group[10].d.j=2; col_group[10].group_id=3;
col_group[11].d.y=0;col_group[11].d.h=6; col_group[11].d.i=0;col_group[11].d.j=3; col_group[11].group_id=2;
col_group[12].d.y=6;col_group[12].d.h=7; col_group[12].d.i=1;col_group[12].d.j=3 ; col_group[12].group_id=2;
col_group[13].d.y=13;col_group[13].d.h=6; col_group[13].d.i=2;col_group[13].d.j=3 ; col_group[13].group_id=2;
col_group[14].d.y=19;col_group[14].d.h=7; col_group[14].d.i=3;col_group[14].d.j=3 ; col_group[14].group_id=2;
col_group[15].d.y=26;col_group[15].d.h=6; col_group[15].d.i=4;col_group[15].d.j=3 ; col_group[15].group_id=1;

//check
int result;
dist->nproc=7;
int max_j=1;
result=measure( col_group,dist->nproc, max_j);
printf("result:%d\n",result);
//MAIN END
}*/

/******************************************FUNCTIONS DEFINATION****************************************************************/
/* MEASURE FUCTION WILL CALCULATE THE COST OF COMMUNICATING PROCESSES*/
int measure( mm_col_i_group *col_group,int total_proc, int max_j)
{
  int current_y=0;
  int tmp_current_y;
  int max_y=0;
  int work_array[max_j];
  int i;
  int j=0;
  int index_max_y=0;
  int unique;
  int smallest_index;
  int smallest_value;
  int top_h, top_g;
  int* group_id_final = (int*)malloc(sizeof(int) * total_proc);
  int* height   = (int*)malloc(sizeof(int) * total_proc);
  memset(group_id_final,0,sizeof(int) * total_proc);
  memset(height,0,sizeof(int) * total_proc);
  /* INITIALIZE STACK*/
  init(&top_h);
  init(&top_g);

  /* USE TO GET MAXIMUN 'Y' VALUE OF PARTITIONING AND ITS INDEX*/
  for (i = 0; i < total_proc; i++) {
    if (col_group[i].d.y > max_y) {
      index_max_y = i;
      max_y = col_group[i].d.y;
    }
  }

  int *group_id_local= (int*)malloc(sizeof(int) * (max_j+1));
  /* USE TO INITIALIZE WORK_ARRAY[TOTAL_NO_OF_COLUMN] WITH ELEMENTS WHICH HAS 'Y' POSITION=0*/
  for (i = 0; i < total_proc; i++) { 
    if(col_group[i].d.y==0){
      work_array[j]=i ;
      j++;
    }
  }
  // printf("Work_array:");
  // for (i = 0; i <= max_j; i++) {
  //   printf("%d\t",work_array[i]);
  // }
  // printf("\n");
  int tmp = max_y+col_group[index_max_y].d.h;
  //printf("tmp= %d \n",tmp);
  while (current_y<tmp)
  {
    smallest_element_index(work_array,col_group,max_j,current_y,&smallest_index,&smallest_value);
    //printf("smallest index:%d, smallest_element:%d\n",smallest_index,smallest_value);

    /*PUSH GROUP ID OF ALL ELEMENTS OF WORK_ARRAY[] INTO GROUP_ID_LOCAL*/
    for (i = 0; i <= max_j; i++){
      group_id_local[i]=col_group[work_array[i]].group_id;
    }
    // for (j=0; j<=max_j; j++){
    //         printf ("%d\n ",group_id_local[j]);
    // }
    /* GET NO OF UNIQUE GROUPS COMMUNICATING AT SPECIFIC LINE*/
    unique=uniq_group(group_id_local,max_j);
    //     printf( "Unique group communicating are:%d\n",unique);
    /*PUSH 'UNIQUE' VALUE INTO GROUP_ID_FINAL[] AND HEIGHT OF SMALLEST ELEMENT INT HEIGHT[]*/
    tmp_current_y=current_y;//Store previous current_y value
    /* CALCULATE UPDATED VALUE OF CURRENT_Y*/
    current_y= col_group[smallest_value].d.h + col_group[smallest_value].d.y;
    //    printf("current_y=%d\n",current_y);

    push_height (height,&top_h,current_y-tmp_current_y);
    push_group_id (group_id_final,&top_g,unique);
    //   for (i=0;i<total_proc;i++){
    //     printf ("height:%d and group_id_final:%d\n",height[i],group_id_final[i]);
    //   }	

    /*INSERT NEXT ELEMENT TO THE POSITION OF MIN ELEMENT INTO WORK_ARRAY*/
    if (col_group[smallest_value].d.j==col_group[smallest_value+1].d.j){
      work_array[smallest_index]= smallest_value+1;
    }

    //    printf("Work_array after insertion:");
    //    for (i = 0; i <= max_j; i++) {
    //      printf("%d\t",work_array[i]);
    //    }
    //    printf("\n");
  }
  int result=0;
  /* SUM OF MULTIPLICATION OF ALL HEIGHT WITH THEIR CORESPONDING TOTAL COMMUNICATING GROUPS*/ 
  for (i=0; i<total_proc;i++){
    result+= height[i]*group_id_final[i];
  }
  //  printf("Communication cost is:%d\n",result);

  //  free(height);
  //  free(group_id_final):
  //  free(group_id_local);
  return result;
}


/* RETURN INDEX OF SMALLEST ELEMENT IN AN ARRAY AND ITS VALUE*/
int smallest_element_index(int* work_array,mm_col_i_group *col_group, int max_j,int current_y, int* smallest_index, int* smallest_value)
{
  *smallest_index= 0;
  int i;
  for( i = 1; i <= max_j; i++){
    if( (col_group[work_array[i]].d.h+ col_group[work_array[i]].d.y-current_y) < (col_group[work_array[*smallest_index]].d.h+ col_group[work_array[*smallest_index]].d.y-current_y)){
      *smallest_index = i;
    }
  }
  *smallest_value= work_array[*smallest_index];
}

/* COMPARE FUNCTION FOR USING QSORT()*/
int cmpfunc (const int *a, const int *b)
{
  if (*a <  *b) return -1;
  if (*a == *b) return  0;
  if (*a >  *b) return  1;
}
/* RETURN TOTAL NO OF UNIQUE GROUPS COMMUNICATING AT HORIZONTAL LINE*/
int uniq_group(int* group_id_local,int max_j)
{
  qsort(group_id_local,max_j+1, sizeof(int),(void *)cmpfunc);
  //  int j;
  //  printf ("sorted Array:\n");
  //  for (j=0; j<=max_j; j++){	
  //    printf ("%d\n ",group_id_local[j]);
  //  }
  int unique = 1; //in-case we have only one element; it is unique!
  int i;
  for(i = 1; i <= max_j; i++){
    if(group_id_local[i]==group_id_local[i-1])
      continue;
    else
      unique++;
  }
  return unique;
}

/*INITIALIZE STACK POINTER */
void init(int* top)
{
  *top = 0;
}

/*PUSH FUNCTION FOR HEIGHT ARRAY*/
void push_height (int* array,int *top, int value)
{
  array [(*top)++] = value;
}
/*PUSH FUNCTION FOR FINAL_GROUP_ID ARRAY*/
void push_group_id (int* array,int *top, int value)
{
  array [*top] = value;
  *top +=1;
}
