#ifndef GROUP_BASED_PARTITION_H
#define GROUP_BASED_PARTITION_H

#include <stdio.h>
#include "mm_col_distr.h"
#include "partition.h"

#ifdef __cplusplus
extern "C" {
#endif

  /* RETURN INDEX OF SMALLEST ELEMENT IN AN ARRAY AND ITS VALUE*/
  int smallest_element_index(int* work_array, mm_col_i_group *col_group, int max_j, int current_y, int* smallest_index, int* smallest_value);

  /* MEASURE FUCTION WILL CALCULATE THE COST OF COMMUNICATING PROCESSES*/
  int measure(mm_col_i_group *col_group,int total_proc, int max_j);

  /* RETURN TOTAL NO OF UNIQUE GROUPS COMMUNICATING AT HORIZONTAL LINE*/
  int uniq_group(int* group_id_local,int max_j);

  /*PUSH FUNCTION FOR HEIGHT ARRAY*/
  void push_height (int* array,int *top_h,int value);

  /*PUSH FUNCTION FOR FINAL_GROUP_ID ARRAY*/
  void push_group_id (int* array,int *top_g,int value);

  /*INITIALIZE STACK POINTER */
  void init(int *top);



#ifdef __cplusplus
}
#endif

#endif /* GROUP_BASED_PARTITION_H */
