#include <stdio.h>
#include <stdlib.h>
#include "partition.h"
#include <string.h>
#include "fupermod/fupermod.h"
#include <gsl/gsl_permutation.h>
#include "group_based_partition.h"


int compare(mm_col_i_group * , mm_col_i_group *);
int compare_j_i(mm_col_i_group *elem1 , mm_col_i_group *elem2);
typedef int (*compfn)(const void*, const void*);
int factorial( int n );
void re_arrange_i_y(int col, int total_proc, mm_col_i_group *);
unsigned concatenate(unsigned x, unsigned y);
void print(int total_proc, mm_col_i_group *col_group);
int smallest_index(int itr, int *measure_result);
int* smallest_indexes_array(int itr,int *measure_result,int *size);
void group_based_partition(mm_col_i_group *col_group,const int total_proc);
void re_arrange_proc(int q,int i,int *join,int ptr,int *perm_array,mm_col_i_group *col_group,mm_col_i_group *tmp,int col_elem);
int mm_col_i_group_write(FILE* stream, mm_col_i_distrib* idist, mm_col_i_group *col_group);

/* MAIN PROGRAM TO CHECK CHECK "GROUP_BASED_PARTITION" FUNCTION
   int main(int argc, char** argv) {	

   mm_col_i_distrib* dist;
   dist =(mm_col_i_distrib*)calloc(sizeof(mm_col_i_distrib),1);
   mm_col_i_group col_group[16];
   mm_col_i_group col_group_tmp[16];
   dist->nproc=16;

//	int count = sizeof(col_group) / sizeof(struct mm_col_i_group);
//	col_group = malloc (sizeof(struct mm_col_i_group*) * count);
//tmp = (mm_col_i_group*)malloc(sizeof(mm_col_i_group) * 16);

col_group[0].d.y=0;col_group[0].d.h=11; col_group[0].d.i=0;col_group[0].d.j=0; col_group[0].group_id=0;
col_group[1].d.y=11;col_group[1].d.h=10; col_group[1].d.i=1;col_group[1].d.j=0; col_group[1].group_id=0;
col_group[2].d.y=21;col_group[2].d.h=11;col_group[2].d.i=2;col_group[2].d.j=0; col_group[2].group_id=0;
col_group[3].d.y=0;col_group[3].d.h=12; col_group[3].d.i=0;col_group[3].d.j=1; col_group[3].group_id=0;
col_group[4].d.y=12;col_group[4].d.h=7; col_group[4].d.i=1;col_group[4].d.j=1; col_group[4].group_id=3;
col_group[5].d.y=19;col_group[5].d.h=6; col_group[5].d.i=2;col_group[5].d.j=1; col_group[5].group_id=3;
col_group[6].d.y=25;col_group[6].d.h=7; col_group[6].d.i=3;col_group[6].d.j=1; col_group[6].group_id=1;
col_group[7].d.y=0;col_group[7].d.h=8; col_group[7].d.i=0;col_group[7].d.j=2 ; col_group[7].group_id=1;
col_group[8].d.y=8;col_group[8].d.h=8; col_group[8].d.i=1;col_group[8].d.j=2; col_group[8].group_id=1; 
col_group[9].d.y=16;col_group[9].d.h=8; col_group[9].d.i=2;col_group[9].d.j=2; col_group[9].group_id=3;
col_group[10].d.y=24;col_group[10].d.h=8;col_group[10].d.i=3;col_group[10].d.j=2; col_group[10].group_id=3;
col_group[11].d.y=0;col_group[11].d.h=6; col_group[11].d.i=0;col_group[11].d.j=3; col_group[11].group_id=2;
col_group[12].d.y=6;col_group[12].d.h=7; col_group[12].d.i=1;col_group[12].d.j=3 ; col_group[12].group_id=2;
col_group[13].d.y=13;col_group[13].d.h=6; col_group[13].d.i=2;col_group[13].d.j=3 ; col_group[13].group_id=2;
col_group[14].d.y=19;col_group[14].d.h=7; col_group[14].d.i=3;col_group[14].d.j=3 ; col_group[14].group_id=2;
col_group[15].d.y=26;col_group[15].d.h=6; col_group[15].d.i=4;col_group[15].d.j=3 ; col_group[15].group_id=1;

//Function call
group_based_partition(col_group,col_group_tmp,dist->nproc);
//End main
}
 */


void group_based_partition(mm_col_i_group *col_group,const int total_proc)
{

  int i,j,k,l; /* general purpose variable used for loop index */
  int max_j=0;

  mm_col_i_group *col_group_original = (mm_col_i_group*)malloc(total_proc *sizeof(mm_col_i_group));
  mm_col_i_group *col_group_tmp = (mm_col_i_group*)malloc(total_proc *sizeof(mm_col_i_group));
  mm_col_i_group *col_group_tmp_1 = (mm_col_i_group*)malloc(total_proc *sizeof(mm_col_i_group));


  /* USE TO GET NO OF COLUMNS OF PARTITIONING*/
  for (i = 0; i < total_proc; i++) {
    if (col_group[i].d.j > max_j) {
      max_j = col_group[i].d.j;
    }
  }

  /* USE TO GET NO OF ELEMENTS IN EACH COLUMN*/
  int c,r;
  int *col_elem= (int*)malloc(sizeof(int) * (max_j+1));
  for (c=0;c<=max_j;c++){
    int counter=0;
    for (r=0;r< total_proc;r++){
      if (col_group[r].d.j==c)
        counter++;
    }
    col_elem[c]=counter;
  }

  //  printf("Before Sorting\n");
  //  print(total_proc,col_group);
  for (c=0;c<total_proc;c++){
    col_group_original[c]=col_group[c];
  }

  // Sort structure values on the based of "j" & "i"
  qsort(col_group_original,        // Beginning address of array
      total_proc ,                // Number of elements in array
      sizeof (mm_col_i_group ),  // Size of each element
      (compfn)compare_j_i );     // Pointer to compare function

  //  printf("After Sorting\n");
  print(total_proc,col_group_original);

  int result_original;
  result_original=measure(col_group_original,total_proc, max_j);
  printf("Measure for Original :%d\n",result_original);

  // Sort structure values on the based of Group ID in each column
  qsort(col_group,                // Beginning address of array
      total_proc ,                // Number of elements in array
      sizeof (mm_col_i_group ),  // Size of each element
      (compfn)compare );         // Pointer to compare function

  printf("After Sorting Group ID\n");
  print(total_proc,col_group);
  for (i=0; i<=max_j;i++){
    re_arrange_i_y(i, total_proc, col_group);
  }

  printf("change i value\n");
  print(total_proc,col_group);
  /* USE TO GET STARTING INDEX OF ALL COLUMNS J IN THE STRUCTURE*/
  int *ptr= (int*)malloc(sizeof(int) * (max_j+1));
  memset(ptr,-1,sizeof(int) * (max_j+1));
  for ( j = 0;  j < total_proc; ++j) {
    if (col_group[j].d.i==0){
      ptr[col_group[j].d.j] = j;
    }
  }

  int result_2;
  result_2=measure(col_group,total_proc, max_j);
  printf("result after sorting:%d\n",result_2);
  /*.......................MAIN LOOP THAT TAKE COLUMNS AND GENERATE PERMUTATIONS & MEASURE COMMUNICATION CAST.......................*/

  for (i=1;i<=max_j;i++){
    printf("col no :%d\n", i);
    l=0;
    int r,c;
    int q=0;
    int *join = (int*)malloc(sizeof(int) * col_elem[i]);
    memset(join,-1,sizeof(int) * col_elem[i]);
    mm_col_i_group tmp[col_elem[i]];

    /* JOIN THE PROCESS NO'S TOGETHER THAT BELONGS TO SAME GROUP INSIDE COLUMN */
    for (r=0; r<col_elem[i];r++){
      join[q]=r;
      while ((col_group[ptr[i]+r].group_id== col_group[ptr[i]+r+1].group_id) && r+1<col_elem[i]) {
        join[q]= concatenate(r+1, join[q]);
        r++;
      }
      q++;
    }
    for (r=0; r<col_elem[i];r++){
      printf("join_element:%d\n",join[r]);
    }
    /* GENERATE PERMUTATIONS FOR COLUMN*/
    gsl_permutation * p = gsl_permutation_calloc (q);
    gsl_permutation_init (p);
    int *perm_array= (int*)malloc(sizeof(int) * col_elem[i]);
    int itr=0;
    itr= factorial (q);
    int *measure_result= (int*)malloc(sizeof(int) * itr);
    size_t perm_all[itr][col_elem[i]];

    do{
      for (j=0;j<q; j++){
        perm_array[j]= gsl_permutation_get(p,j);
        perm_all[l][j]=perm_array[j];
      }
      printf("After permutation value string is\t");
      for (k=0; k<q; k++){
        printf("%d\t",perm_array[k]);
      }
      printf("\n");
      for (c=0;c<total_proc;c++){
        col_group_tmp[c]=col_group[c];
      }
      re_arrange_proc(q,i,join,ptr[i],perm_array,col_group_tmp,tmp,col_elem[i]);
      //print(dist->nproc,col_group);

      re_arrange_i_y(i,total_proc , col_group_tmp);
      //printf("change i value after permutation\n");
      //print(dist->nproc,col_group_tmp);
      measure_result[l]=measure(col_group_tmp,total_proc, i);
      printf("Measure is:%d\n",measure_result[l]);
      l++;
    } 
    while (gsl_permutation_next(p) == GSL_SUCCESS);
    /*    int o,z;
          for (o=0;o<itr;o++){
          printf("%d permutation value\t",o);
          for (z=0;z<q;z++){
          printf("%u", perm_all[o][z]);
          }
          printf("\n");
          }*/
    int* smallest_index_array_ptr;
    int small_index,size,y;
    small_index=smallest_index(itr,measure_result);
    smallest_index_array_ptr=smallest_indexes_array(itr,measure_result,&size);
    for ( y = 0 ; y < size ; y++ ){
      printf("smallest indexes are:%d\n",smallest_index_array_ptr[y]);
    }

    /*.......... KEEP SMALLEST MEASURE PERMUTATION ORDER IN A COLUMN ..............*/

    int b;
    int *tmp_measure= (int*)malloc(sizeof(int) * size);
    int *tmp_perm= (int*)malloc(sizeof(int) * col_elem[i]);
    if (size==1 || i==max_j){
      for (j=0;j<q; j++){
        tmp_perm[j]= perm_all[small_index][j];
      }
      printf("In If block: Change processes position if have just one smallest index or last column....\n");
      re_arrange_proc(q,i,join,ptr[i],tmp_perm,col_group,tmp,col_elem[i]);
      print(total_proc,col_group);
      re_arrange_i_y(i,total_proc , col_group);
      int result_final;
      result_final=measure(col_group,total_proc, max_j);
      printf("Measure for Group based partition:%d\n",result_final);
      // printf("Change i value\n");
      // print(total_proc,col_group);
    }
    else{
      printf("Else block: If have more then one smallest Index...\n");
      for (b=0;b<size;b++){
        for (c=0;c<total_proc;c++){
          col_group_tmp[c]=col_group[c];
        }
        printf("..............col_group\n");
        print(total_proc,col_group_tmp);
        for (j=0;j<q; j++){
          tmp_perm[j]= perm_all[smallest_index_array_ptr[b]][j];
        }
        for (j=0;j<q; j++){
          printf("tmp_perm:%d\n",tmp_perm[j]);
        }
        re_arrange_proc(q,i,join,ptr[i],tmp_perm,col_group_tmp,tmp,col_elem[i]);
        //print(total_proc,col_group);
        re_arrange_i_y(i,total_proc , col_group_tmp);
        printf("In loop:For each smallest value index:%d ....\n",b);
        int ii=i;
        ii++;
        printf("Check measure for next column :%d\n", ii);
        int ll=0; int rr; int qq=0;
        int *join_tmp = (int*)malloc(sizeof(int) * col_elem[ii]);
        memset(join_tmp,-1,sizeof(int) * col_elem[ii]);
        mm_col_i_group tmp_1[col_elem[ii]];
        // printf("col_elem[ii]:%d\n",col_elem[ii]);
        /* JOIN THE PROCESS NO'S TOGETHER THAT BELONGS TO SAME GROUP INSIDE COLUMN */
        for (rr=0; rr<col_elem[ii];rr++){
          join_tmp[qq]=rr;
          while ((col_group_tmp[ptr[ii]+rr].group_id== col_group_tmp[ptr[ii]+rr+1].group_id) &&rr+1<col_elem[ii] ) {
            join_tmp[qq]= concatenate(rr+1, join_tmp[qq]);
            printf("%d\n",join_tmp[qq]);
            rr++;
            //   if (rr==col_elem[ii]-1)
            // break;
          }
          qq++;
        }
        for (r=0; r<col_elem[ii];r++){
          printf("join_element_tmp:%d\n",join_tmp[r]);
        }
        /* GENERATE PERMUTATIONS FOR COLUMN*/
        gsl_permutation * pp = gsl_permutation_calloc (qq);
        gsl_permutation_init (pp);
        int *perm_array_tmp= (int*)malloc(sizeof(int) * col_elem[ii]);
        int itr_tmp=0;
        itr_tmp= factorial (qq);
        int *measure_result_tmp= (int*)malloc(sizeof(int) * itr_tmp);
        size_t perm_all_tmp[itr_tmp][col_elem[ii]];

        do{
          for (j=0;j<qq; j++){
            perm_array_tmp[j]= gsl_permutation_get(pp,j);
            perm_all_tmp[ll][j]=perm_array_tmp[j];
          }
          for (c=0;c<total_proc;c++){
            col_group_tmp_1[c]=col_group_tmp[c];
          }
          re_arrange_proc(qq,ii,join_tmp,ptr[ii],perm_array_tmp,col_group_tmp_1,tmp_1,col_elem[ii]);
          //print(dist->nproc,col_group_tmp);
          re_arrange_i_y(ii,total_proc , col_group_tmp_1);
          measure_result_tmp[ll]=measure(col_group_tmp_1,total_proc, ii);
          printf("Measure is:%d\n",measure_result_tmp[ll]);
          ll++;
        } 
        while (gsl_permutation_next(pp) == GSL_SUCCESS);
        int small_index_tmp;
        small_index_tmp=smallest_index(itr_tmp,measure_result_tmp);
        tmp_measure[b]=measure_result_tmp[small_index_tmp];
      }

      for (j=0;j<size; j++){
        printf("tmp_measure final:%d\n",tmp_measure[j]);
      }
      int smallest_value;
      smallest_value=smallest_index(size,tmp_measure);
      printf("smallest value in array is:%d\n",smallest_value);
      for (j=0;j<q; j++){
        tmp_perm[j]= perm_all[smallest_index_array_ptr[smallest_value]][j];
      }
      re_arrange_proc(q,i,join,ptr[i],tmp_perm,col_group,tmp,col_elem[i]);
      printf("Rearrange processes accourding to smallest index from smalest index array final\n");
      print(total_proc,col_group);
      re_arrange_i_y(i,total_proc , col_group);
      printf("change i final\n");
      print(total_proc,col_group);
    }
  }

  free(ptr);
  free(col_elem);

}
/* ............................................... FUNCTION DEFINATIONS.....................................................................*/

/*REARRANGE STRUCTURE PROCESSES ACCOURDING TO PERMUTATION ORDER */
void re_arrange_proc(int q,int i,int *join, int ptr,int *perm_array,mm_col_i_group *col_group,mm_col_i_group *tmp, int col_elem )
{
  int split;
  int u,j,k;
  int s=0;
  size_t *mid_tmp_array= (size_t*)malloc(sizeof(size_t) * q);
  for (u=0;u<q; u++){
    mid_tmp_array[u]=join[u];
  }

  for (j=0;j<q; j++){
    do{   
      split = mid_tmp_array[perm_array[j]] % 10;  
      printf("split:%d\n",split); 	
      tmp[s++]= col_group[ptr+split];
      mid_tmp_array[perm_array[j]] /= 10;
    } while (mid_tmp_array[perm_array[j]]);
  }

  for (k=0; k<col_elem; k++) {
    col_group[ptr+k]=tmp[k];
  }
}

/* RE-ARRANGE VALUE OF I AND Y*/
void re_arrange_i_y(int col, int total_proc, mm_col_i_group *col_group)
{
  int i;
  int i_change=0;	
  int y_change=0; 
  for (i = 0; i < total_proc; i++){
    if (col_group[i].d.j==col){
      col_group[i].d.i=i_change;
      col_group[i].d.y=y_change;
      i_change++;
      y_change+=+col_group[i].d.h;
    }
  }
}
/* RETURN PERMUTATION INDEXES ARRAY POINTER FOR SMALLEST MEASURE */
int* smallest_indexes_array(int itr,int *measure_result, int *size)
{
  int index;
  int y;
  int v=0;
  /* USE TO GET THE INDEX OF SMALLEST ELEMENT */
  index=smallest_index(itr,measure_result);
  int *smallest_index_array= (int*)malloc(sizeof(int) * itr);
  for ( y = 0 ; y < itr ; y++ ){
    if (measure_result[y]==measure_result[index]){
      smallest_index_array[v++]= y;
    }
  }
  *size=v;
  return smallest_index_array;
}

/* USE TO GET THE INDEX OF SMALLEST ELEMENT */
int smallest_index(int itr, int *measure_result)
{
  int index=0;
  int y;
  for ( y = 1 ; y < itr ; y++ ){
    if ( measure_result[y] < measure_result[index] ){
      index = y;
    }
  } 
  return index;
}

/* COMPARE FUNCTION FOR USING QSORT ON THE BASES OF GROUP ID()*/
int compare(mm_col_i_group *elem1 , mm_col_i_group *elem2)
{
  if ( elem1->d.j < elem2->d.j)
    return -1;
  else if (elem1->d.j > elem2->d.j)
    return 1;
  else if ( elem1->group_id < elem2->group_id)
    return -1;
  else if (elem1->group_id > elem2->group_id)
    return 1;
  else
    return 0;
}

/* COMPARE FUNCTION FOR USING QSORT() TO SORT ROWS ON THE BASES OF "J" AND "I"*/
int compare_j_i(mm_col_i_group *elem1 , mm_col_i_group *elem2)
{
  if ( elem1->d.j < elem2->d.j)
    return -1;
  else if (elem1->d.j > elem2->d.j)
    return 1;
  else if ( elem1->d.i < elem2->d.i)
    return -1;
  else if (elem1->d.i > elem2->d.i)
    return 1;
  else
    return 0;
}

/* FUNCTION TO CALCULATE THE FACTORIAL OF A NUMBER*/ 
int factorial( int n )
{
  if( n <= 0 )  return 1 ; // safeguard 0 and -ve
  int res = n ;
  while( --n>1 ) res *= n ;
  return res ;
}

/* FUNCTION TO CONCATENATE INTEGER VALUES OF SAME GROUP IN A COLUMN*/
unsigned concatenate(unsigned x, unsigned y) {
  unsigned pow = 10;
  while(y >= pow)
    pow *= 10;
  return x * pow + y;        
}
/* PRINT STRUCTURE VALUE */ 
void print(int total_proc, mm_col_i_group *col_group)
{
  int m;
  for (m = 0; m < total_proc; m++){
    printf("i:%d\tj:%d\tx:%d\ty:%d\tw:%d\th:%d\tgroup_id:%d\t  \n",
        col_group[m].d.i,col_group[m].d.j,col_group[m].d.x,col_group[m].d.y,col_group[m].d.w,col_group[m].d.h, col_group[m].group_id);
  }
}

/* FUNCTION TO WRITE GROUP BASED PARTITION DATA ON FILE */
int mm_col_i_group_write(FILE* stream, mm_col_i_distrib* idist, mm_col_i_group *col_group) {
  int kb = idist->kb;
  fprintf(stream, "#size %d\n", idist->nproc);
  fprintf(stream, "#N %d\n", idist->N);
  fprintf(stream, "#kb %d\n", kb);
  fprintf(stream, "%-15s  rank_intra\ti\tj\tx\ty\tw\th\tw*h\tmem\ttime\tGroup_id\n", "#host");
  int i;
  for (i = 0; i < idist->nproc; i++) {
    fprintf(stream, "%-20s\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%lld\t%dMB\t%lf\t%d\n",
        col_group[i].hostname,
        col_group[i].core_id,
        col_group[i].d.i, 
        col_group[i].d.j,
        col_group[i].d.x, 
        col_group[i].d.y,
        col_group[i].d.w,
        col_group[i].d.h,
        (long long int)col_group[i].d.w * col_group[i].d.h,
        (int)(8 * (3.0 * col_group[i].d.w *	col_group[i].d.h * kb * kb +  kb * col_group[i].d.w + kb * col_group[i].d.h)/1024/1024),
        col_group[i].time,col_group[i].group_id
        );
  }
  return 0;
}
