#ifndef PARTITION_H
#define PARTITION_H

#include <stdio.h>
#include "mm_col_distr.h"
//#include "group_based_partition.h"

#ifdef __cplusplus
extern "C" {
#endif

  /*! structure describing Group ID,size and coordinates 
   * of elements assigned to a single processor  */

  typedef struct mm_col_i_group{
    /*! mm_col_i_zone element */
    mm_col_i_zone d;
    /*! Host ID */
    int hostname;
    /*! Core ID */
    int core_id;
    /*! Group ID */
    int group_id;
    /*! Time */
    double time;
  } mm_col_i_group;

  /*!......................... FUNCTIONS DECLERATION................................. */

  /* FUNCTION TO CALCULATE THE FACTORIAL OF A NUMBER*/ 
  int factorial( int n );

  /* RE-ARRANGE VALUE OF I AND Y*/
  void re_arrange_i_y(int col, int total_proc, mm_col_i_group *);

  /* FUNCTION TO CONCATENATE INTEGER VALUES OF SAME GROUP IN A COLUMN*/
  unsigned concatenate(unsigned x, unsigned y);

  /* PRINT MM_COL_I_GROUP STRUCTURE VALUE */ 
  void print(int total_proc, mm_col_i_group *col_group);

  /* USE TO GET THE INDEX OF SMALLEST ELEMENT */
  int smallest_index(int itr, int *measure_result);

  /* RETURN PERMUTATION INDEXES ARRAY POINTER FOR SMALLEST MEASURE */
  int* smallest_indexes_array(int itr,int *measure_result,int *size);

  /*fUNCTION THAT WILL RETURN PARTITION BASED ON GROUP */
  void group_based_partition(mm_col_i_group *col_group,const int total_proc);

  /*REARRANGE STRUCTURE PROCESSES ACCOURDING TO PERMUTATION ORDER */
  void re_arrange_proc(int q,int i,int *join,int ptr,int *perm_array,mm_col_i_group *col_group,mm_col_i_group *tmp,int col_elem);

  /* FUNCTION TO WRITE GROUP BASED PARTITION DATA ON FILE */
  int mm_col_i_group_write(FILE* stream, mm_col_i_distrib* idist,mm_col_i_group *col_group);

#ifdef __cplusplus
}
#endif

#endif /* GROUP_BASED_PARTITION_H */
