#ifndef FUPERMOD_H_
#define FUPERMOD_H_

/*!
 * \page fupermod Functional performance model
 * The library has the following structure:
 * - \subpage fupermod_conf_group
 * - \subpage fupermod_kernel_group
 * - \subpage fupermod_benchmark_group
 * - \subpage fupermod_data_group
 * - \subpage fupermod_model_group
 * - \subpage fupermod_partition
 * - \subpage fupermod_dynamic_group
 *
 * \dotfile fupermod/modules.dot
 *
 * \section tools Tools
 * - \subpage builder
 * - \subpage modeller
 * - \subpage model_smoother
 * - \subpage partitioner
 * - \subpage dyparter
 * - \subpage hybrid_parter
 *
 * \section routines Routines
 * - \subpage template_routine
 * - \subpage mxm_col
 * - \subpage jacobi
 */

#include "fupermod_dynamic.h"

#endif /*FUPERMOD_H_*/
