#include "fupermod_debug.h"
#include "fupermod_benchmark.h"
#include "fupermod_model.h"
#include <stdlib.h>

/*! Benchmark that looks up the models loaded from files at all processes */
typedef struct fupermod_benchmark_emulate {
  /*! Base */
  fupermod_benchmark base;
  /*! Model */
  fupermod_model* model;
} fupermod_benchmark_emulate;

int fupermod_benchmark_emulate_execute(struct fupermod_benchmark* benchmark, MPI_Comm comm, long long int d, fupermod_precision precision, fupermod_point* point) {
  NOT_USED(precision);
  NOT_USED(comm);
  fupermod_benchmark_emulate* emulate = (fupermod_benchmark_emulate*)benchmark;
  point->d = d;
  point->t = fupermod_model_speed(emulate->model, d);
  point->reps = 0;
  point->ci = 0;
  return 0;
}

fupermod_benchmark* fupermod_benchmark_emulate_alloc(fupermod_kernel* kernel, struct fupermod_model* model) {
  fupermod_benchmark_emulate* emulate = (fupermod_benchmark_emulate*)malloc(sizeof(fupermod_benchmark_emulate));
  fupermod_benchmark* benchmark = (fupermod_benchmark*)emulate;
  benchmark->kernel = kernel;
  benchmark->execute = fupermod_benchmark_emulate_execute;
  emulate->model = model;
  return benchmark;
}

void fupermod_benchmark_emulate_free(fupermod_benchmark* benchmark) {
  free(benchmark);
}
