#include "fupermod_timer.h"
#include "fupermod_dynamic.h"
#include <stdlib.h>
#include <math.h>

int fupermod_balancer_iterate(fupermod_dynamic* balancer, MPI_Comm comm,
    int root, struct timespec start) {
  // measure and gather the execution times
  struct timespec end;
  get_time(&end);
  double time = get_timediff(&end, &start);
  int rank;
  MPI_Comm_rank(comm, &rank);
  int size;
  MPI_Comm_size(comm, &size);
  double* times = NULL;
  if (rank == root)
    times = (double*)malloc(sizeof(double) * size);
  MPI_Gather(&time, 1, MPI_DOUBLE, times, 1, MPI_DOUBLE, root, comm);

  // update models
  if (rank == root) {
    int i;
    for (i = 0; i < balancer->size; i++) {
      /*fupermod_data_add(balancer->models[i]->data,
        (fupermod_point){balancer->dist->parts[i].d, times[i], 0, 0}); */
      balancer->models[i]->update(balancer->models[i], (fupermod_point){balancer->dist->parts[i].d, times[i], 0, 0});
    }
  }
  free(times);

  // partition
  if (rank == root) {
    // start with equal distribution
    fupermod_dist* new_dist = fupermod_dist_alloc(balancer->size, balancer->dist->D);
    balancer->partition(new_dist, balancer->size, balancer->models);
    fupermod_dist_free(balancer->dist);
    balancer->dist = new_dist;
  }
  return 0;
}
