#include "fupermod_debug.h"
#include "fupermod_model_interp.h"

/*! The constant model. Uses the Akima spline interpolation of real observations */
typedef struct fupermod_model_constant_interp {
  /*! Base */
  fupermod_model_interp base;
  /*! A data point whose time approximation will be used as the value of the constant model */
  int bench_size;
  /*! Functional model */
  fupermod_model* model_interp;
} fupermod_model_constant_interp;

double fupermod_model_constant_interp_t(struct fupermod_model* model, double x) {
  fupermod_model_constant_interp* model_constant_interp = (fupermod_model_constant_interp*)model;
  return fupermod_model_interp_t(model_constant_interp->model_interp, model_constant_interp->bench_size * model->complexity(x, NULL) / model->complexity(model_constant_interp->bench_size, NULL));
}
double fupermod_model_constant_interp_dt(struct fupermod_model* model, double x) {
  NOT_USED(model);
  NOT_USED(x);
  return 0;
}

fupermod_model* fupermod_model_constant_interp_alloc(fupermod_data* data, fupermod_complexity complexity, long long int D, void* params, int bench_size) {
  NOT_USED(params);
  fupermod_model_constant_interp* constant = (fupermod_model_constant_interp*)malloc(sizeof(fupermod_model_constant_interp));
  fupermod_model* model = (fupermod_model*)constant;
  model->data = data;
  model->complexity = complexity;
  model->D = D;
  model->t = fupermod_model_constant_interp_t;
  model->dt = fupermod_model_constant_interp_dt;
  model->update = NULL;
  constant->bench_size = bench_size;
  constant->model_interp = fupermod_model_interp_alloc(data, complexity, D, NULL, 0);
  return model;
}

void fupermod_model_constant_interp_free(fupermod_model* model) {
  fupermod_model_interp_free(((fupermod_model_constant_interp*)model)->model_interp);
  free(model);
}
