#ifndef FUPERMOD_MODEL_INTERP_H_
#define FUPERMOD_MODEL_INTERP_H_

#include "fupermod_model.h"
#include <gsl/gsl_spline.h>

#ifdef __cplusplus
extern "C" {
#endif

  /*! The Akima spline interpolation */
  typedef struct fupermod_model_interp {
    /*! Base */
    fupermod_model base;
    /*! Smooth parameter for the Akima spline interpolation of full functional performance models (0 - no smoothing) */
    int smooth;
    /*! Interpolation accelerator */
    gsl_interp_accel* accel;
    /*! Interpolation spline */
    gsl_spline* spline;
  } fupermod_model_interp;

  double fupermod_model_interp_t(struct fupermod_model* model, double x);

#ifdef __cplusplus
}
#endif

#endif /* FUPERMOD_MODEL_INTERP_H_ */
