#include "fupermod_debug.h"
#include "fupermod.h"
#include <stdlib.h>
#include <stdio.h>

int fupermod_partition_basic(fupermod_dist* dist, int size, fupermod_model** models) {
  double SAS = 0; //sum of absolute speed
  int i;
  double* speeds = (double*)malloc(sizeof(double) * size);
  for (i = 0; i < size; i++) // absolute speed
    SAS += speeds[i] = models[i]->complexity(100, NULL) / (models[i]->t(models[i], 100));
  double* rs = (double*)malloc(size * sizeof(double)); // relative speed
  for (i = 0; i < size; i++) // relative speed
    rs[i] = speeds[i] / SAS;
  long long int sum_d = 0;
  for (i = 0; i < size; i++)
    sum_d += dist->parts[i].d = (int)(dist->D * rs[i]);
  free(rs);

  int remain = dist->D - sum_d;
  i = 0;
  while (remain > 0) { //distribute remainder
    dist->parts[i].d++;
    i++;
    remain--;
  }
  // final check
  sum_d = 0;
  for (i = 0; i < size; i++)
    sum_d += dist->parts[i].d;
  if (sum_d != dist->D){
    fprintf(stderr, "Error in function: %s, dist doesn't add up, sum_d:%lld D:%lld\nExiting\n", __func__, sum_d, dist->D);
    return -1;
  }
  for (i = 0; i < size; i++)
    dist->parts[i].t = models[i]->complexity(dist->parts[i].d, NULL) / speeds[i];
  free(speeds);
  return 0;
}

int fupermod_partition_homogeneous(fupermod_dist* dist, int size, fupermod_model** models) {
  NOT_USED(models);
  int i;
  for (i = 0; i < size; i++)
    dist->parts[i].d = dist->D / size + ((i < dist->D % size) ? 1 : 0);
  // final check
  long long int sum_d = 0;
  for (i = 0; i < size; i++)
    sum_d += dist->parts[i].d;
  if (sum_d != dist->D){
    fprintf(stderr, "Error in function: %s, dist doesn't add up, sum_d:%lld D:%lld\nExiting\n", __func__, sum_d, dist->D);
    return -1;
  }
  return 0;
}
