#!/usr/bin/env python

"""

"""
 
__appname__ = "Builder_extrae"
__author__  = "Dave Clarke & HCL"
__version__ = "0.1.0"
__license__ = "GNU GPL 3.0 or later"
__doc__ = ""
 
import logging
log = logging.getLogger(__name__)
 
import sys
import subprocess

size = 0
N = 0
k = 4

def initialise():
  print('Initialize function')
  #subprocess.check_call(["echo", "hello world"])
  
  # Set up config and short empty files.
  builder_str = "mpirun -np " + str(size) + " --machinefile machinefile builder -l ~/lib/libmxm_1d.so -o k=" + str(k)
  print("Exec:" + builder_str)
  subprocess.check_call(builder_str, shell=True)

  #subprocess.check_call("mpirun builder -l ~/lib/libmxm_1d.so", shell=True)
  #subprocess.check_call(["mpirun", "-np 4 builder -l ~/lib64/libmxm_1d.so"])

def execute():
  print('ex function')
  # Call partitioner with homogeneous distribution -a 0
  partitioner_str = "partitioner -a 0 -l ~/lib/libmxm_1d.so -D" + str(N * N)
  print("Exec:" + partitioner_str)
  subprocess.check_call(partitioner_str, shell=True)

  parter2d_str = "1dto2d_dist -k " + str(k) + " -N" + str(k * N)
  print("Exec:" + parter2d_str)
  subprocess.check_call(parter2d_str, shell=True)

  execute_str = "mpirun -np " + str(size) + " --machinefile machinefile trace.sh mxm_2d"
  print("Exec:" + execute_str)
  sys.stdout.flush()
  subprocess.check_call(execute_str, shell=True)

def finalise():
  print('finilise function')
  # maybe do some rm here. 

def main():
  if len(sys.argv) != 4:
    print_help()
    raise Exception("Incorrect number of args")
  global size
  size = int(sys.argv[2])
  global N
  N = int(sys.argv[3])
  methods = {'i': initialise, 'e': execute, 'f': finalise}
  method_name = sys.argv[1]
  if method_name in methods:
    methods[method_name]()
  else:
    print_help
    raise Exception("Method %s not implemented, should be i,e or f" % method_name)
    

def print_help():
  print('Usage: %s method np N\n'
      '\tmethods i|e|f for initialise, execute or finalise\n'
      '\tnp      number of MPI processes to run\n'
      '\tN       problem size\n'
      % sys.argv[0])

if __name__ == '__main__':
  main()
