/*! Kernel of the \ref mxm routine */

#include "config.h"
#include "fupermod/fupermod_debug.h"
#include "mxm_kernel.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int unload(MPI_Comm comm) {
  NOT_USED(comm);
  return FUPERMOD_SUCCESS;
}

double complexity_1d(long long int area, void* param){
  int myw, myh;
  myw = myh = sqrt(area);
  return complexity_2d(myh, myw, param);
}

int initialize_1d(long long int area, void** params){
  int myw, myh;
  myw = myh = sqrt(area);
  return initialize_2d(myh, myw, params);
}

int execute_1d(pthread_mutex_t *mutex, void* params) {    
  return execute_2d(mutex, params);
}

int finalize_1d(void* params){
  return finalize_2d(params);
}

fupermod_kernel fupermod_kernel_instance = {
  load,
  unload,
  complexity_1d,
  initialize_1d,
  execute_1d,
  finalize_1d
};
