#ifndef MXM_2D_H_
#define MXM_2D_H_

#include <mpi.h>
#include "cblas_wrappers/fupermod_memory.h"
#include "cblas_wrappers/fupermod_cblas.h"
#include "datapart_2d/mm_col_distr.h"

/*! fupermod_dgemm workspace */
typedef struct fupermod_dgemm_workspace {
  /*! GEMM workspace */
  fupermod_gemm* gemm;
  /*! Workspace A */
  fupermod_float *WA;
  /*! Workspace B */
  fupermod_float *WB;
  /*! Column-wise 2D partitioning */
  mm_col_i_distrib* idist;
} fupermod_dgemm_workspace;

/*! allocate workspace for fupermod dgemm */
fupermod_dgemm_workspace* fupermod_dgemm_alloc(MPI_Comm comm, FILE* stream, fupermod_process_conf* confs, fupermod_gemm* gemm);

/*! free workspace */
void fupermod_dgemm_free(fupermod_dgemm_workspace* w, fupermod_process_conf* conf);

/*! fupermod heterogeneous dgemm */
int fupermod_dgemm(fupermod_float *A, fupermod_float *B, fupermod_float *C, MPI_Comm comm, fupermod_dgemm_workspace* w);

#endif /* MXM_2D_H_ */
