#ifndef MXM_KERNEL_H_
#define MXM_KERNEL_H_

#include <mpi.h>
#include "fupermod/fupermod_kernel.h"
#include "fupermod_2d/fupermod_2d_kernel.h"
#include "cblas_wrappers/fupermod_memory.h"
#include "cblas_wrappers/fupermod_cblas.h"
#include "datapart_2d/mm_col_distr.h"

/*! Set global variables from suboptions */
int load(MPI_Comm _comm, fupermod_process_conf* conf);

/*! Returns 2D complexity */
double complexity_2d(long long int m, long long int n, void* param);

/*! Returns complexity from 1 paramater and uses void param for second parameter. param cannot be null*/
double complexity_1dfrom2d(long long int m, void* param);

/* Initializes 2D kernel */
int initialize_2d(long long int m, long long int n, void** params);

/* Executes 2D kernel */
int execute_2d(pthread_mutex_t* mutex, void* params);

/* Finalizes 2D kernel */
int finalize_2d(void* params);


#endif /* MXM_KERNEL_H_ */
