#ifndef MXM_COL_H_
#define MXM_COL_H_

#include <mpi.h>
//#include "mxm_cblas.h"
#include "datapart_2d/mm_col_distr.h"

/*! fupermod_dgemm workspace */
typedef struct fupermod_dgemm_workspace {
  /*! block size */
  int kb;
  /*! Matrix size (square matrix!) */
  int N;
  /*! Workspace A */
  double *WA;
  /*! Workspace B */
  double *WB;
  mm_col_i_distrib* idist;
} fupermod_dgemm_workspace;

/*! allocate workspace for fupermod dgemm */
//fupermod_dgemm_workspace* fupermod_dgemm_alloc(MPI_Comm comm, int N, int kb, long long int area);
fupermod_dgemm_workspace* fupermod_dgemm_alloc_car(MPI_Comm comm, int N, int kb, long long int area, fupermod_process_conf* confs, char* distfile);

/*! free workspace */
//void fupermod_dgemm_free(fupermod_dgemm_workspace* w);
void fupermod_dgemm_free_car(fupermod_dgemm_workspace* w);

/* fupermod heterogeneous dgemm */
int fupermod_dgemm_car(double *A, double *B, double *C, MPI_Comm comm, fupermod_dgemm_workspace* w);

#endif /* MXM_COL_H_ */
