#ifndef DGEMM_HYBRID_H
#define DGEMM_HYBRID_H

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#ifdef _OPENMP
#include <omp.h>
#endif



#ifdef __cplusplus
extern "C" {
#endif

int dgemm_initialize (int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig CONFIG);
int dgemm_hybrid (int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig CONFIG);
int dgemm_finalize (int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig CONFIG);

#ifdef __cplusplus
}
#endif


#endif




