#include "fupermod/fupermod_debug.h"
#include "mxm_hybrid.h"
#include <unistd.h>
#include <gsl/gsl_cblas.h>
#include <stdlib.h>

int dgemm_initialize(int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig CONFIG){
  NOT_USED(M);
  NOT_USED(N);
  NOT_USED(K);
  NOT_USED(alpha);
  NOT_USED(A);
  NOT_USED(lda);
  NOT_USED(B);
  NOT_USED(ldb);
  NOT_USED(beta);
  NOT_USED(C);
  NOT_USED(ldc);
  NOT_USED(CONFIG);
  return 0;
}

int dgemm_hybrid(int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig config){
  int rank;
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  int size = config.numGPUs + config.numCPUs;

  fprintf(stderr, "P%d:*** Running fake dgemm with M%d N%d K%d alpha%lf lda%d ldb%d beta%lf ldc%d\n", rank, M, N, K, alpha, lda, ldb, beta, ldc);
  fprintf(stderr, "*** with workload: ");
  int i;
  for (i = 0; i < size; i++)
    fprintf(stderr, "%d ", config.deviceWorkload[i]);
  fprintf(stderr, "\n");

  double speed[] = {100, 20, 11, 10, 12, 20};
  for (i = 0; i < size; i++){
    config.deviceTime[i] = config.deviceWorkload[i] / (speed[i] * (rank + 1));
  }
  fprintf(stderr, "*** Running cblas_dgemm - not hybrid!!!\n");
  cblas_dgemm(CblasColMajor, CblasNoTrans, CblasNoTrans, M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
  return 0;
}

int dgemm_finalize (int M, int N, int K, double alpha, double *A, int lda, double *B, int ldb, double beta, double *C, int ldc, HybridConfig CONFIG){
  NOT_USED(M);
  NOT_USED(N);
  NOT_USED(K);
  NOT_USED(alpha);
  NOT_USED(A);
  NOT_USED(lda);
  NOT_USED(B);
  NOT_USED(ldb);
  NOT_USED(beta);
  NOT_USED(C);
  NOT_USED(ldc);
  NOT_USED(CONFIG);
  return 0;
}

int malloc_hybrid(int size, double **A, memoryMode MEM_MODE){
  NOT_USED(MEM_MODE);
  *A = (double*)malloc(size);
  return 0;
}

int free_hybrid(double *A, memoryMode MEM_MODE){
NOT_USED(MEM_MODE);
	free(A);
	return 0;
}
