#include "examples/fupermod_bcast.h"
#include "fupermod/fupermod_timer.h"
#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char **argv){
  int myrank;
  int NB_proc;
  int size = 10000;
  if (argc>= 2)
    size = atoi(argv[1]);
  int first_algo=0;
  int last_algo=5;
  if (argc>= 3)
    first_algo = atoi(argv[2]);
  if (argc>= 4)
    last_algo = atoi(argv[3]);
  MPI_Init(&argc, &argv);
  struct timespec start_time, end_time; //time mesure
  int * send = malloc( sizeof(int)*size );
  int * recv = malloc( sizeof(int)*size );
  int i,j;
  MPI_Comm_rank ( MPI_COMM_WORLD, &myrank );
  MPI_Comm_size ( MPI_COMM_WORLD, &NB_proc );
  fprintf(stderr,"myrank: %d\n",myrank);
  fflush(stderr);
  for( i=0; i < size; i++) send[i] = myrank + i;

  MPI_Barrier(MPI_COMM_WORLD);
  for(i = first_algo; i< last_algo;i++){
    if(myrank == 0)
    {
      fprintf(stderr,"try algorithm: %d\n",i);
      fflush(stderr);
    }
    for(j = 0; j< NB_proc;j++){

      if(myrank == 0)
        fprintf(stderr,"  try rank: %d\n",j);
      fflush(stderr);
      MPI_Barrier(MPI_COMM_WORLD);


      get_time(&start_time);
      if(myrank == j)
      {
        if(send[0] != j)
          fprintf(stderr," rank: %d   sent of : %d instead of : %d\n",myrank,send[0],j);
        else
          fprintf(stderr,"    good sent\n");
        fupermod_bcast(send, size, MPI_INT, j, MPI_COMM_WORLD,i);
      }
      else
        fupermod_bcast(recv, size, MPI_INT, j, MPI_COMM_WORLD,i);

      get_time(&end_time);


      double time = get_timediff(&start_time,&end_time);
      MPI_Barrier(MPI_COMM_WORLD);
      if(myrank != j && recv[0] == j)
        fprintf(stderr,"    good reception\n");
      else if(myrank != j && recv[0] != j)
        fprintf(stderr," rank: %d   reception of : %d instead of : %d\n",myrank,recv[0],j);
      fflush(stderr);

      MPI_Barrier(MPI_COMM_WORLD);
      fprintf(stderr,"    rank : %d algorithm: %d time: %le\n",myrank, i,time);
      fflush(stderr);
      MPI_Barrier(MPI_COMM_WORLD);
      fprintf(stderr,"\n\n");
      fflush(stderr);
      MPI_Barrier(MPI_COMM_WORLD);
    }
    MPI_Barrier(MPI_COMM_WORLD);
  }
  return 0;
}
