/*!
 * Programme to test ratio of partitioning with mm_col. How square is the results?
 */
#include "config.h"
#include "fupermod/fupermod_debug.h"
#include "datapart_2d/mm_col_distr.h"
//#include <getopt.h>
#include <stdio.h>
//#include <string.h>
//#include <dlfcn.h>
//#include <unistd.h>
#include <stdlib.h>
//#include <stdlib.h>
#define M 20

int main(int argc, char** argv) {
  NOT_USED(argc);
  NOT_USED(argv);
  int N = 100000; // doesn't affect ratios, just something large to avoid rounding.
  int kb = 16;
  int size = 10; // change randomly
  double machines[M] = {
    5.21e9, 
    4.72e9, 
    4.00e9, 
    3.92e9, 
    2.83e9, 
    2.22e9, 
    1.28e9, 
    1.23e9, 
    1.17e9, 
    1.08e9, 
    1.01e9, 
    8.85e8, 
    8.65e8, 
    8.26e8, 
    5.81e8, 
    5.50e8, 
    5.11e8, 
    5.00e8, 
    4.83e8, 
    3.35e8
  };
  for (size = 1; size < 1000; size++) {
    double* areas = (double*)malloc(sizeof(double) * size);
    int i;
    for (i = 0; i < size; i++){
      int r = (int)((0)+rand()/(RAND_MAX+1.0) * ((M-1)-(0)+1));
      //printf("rand: %d\n", r);
      areas[i] = machines[r];
    }
    //	areas[0] = 1; // one slow proc
    //	areas[1] = 100; // one fast proc

    mm_col_i_distrib* idist = mm_col_dist(size, N, kb, areas);
    // analyse results
    for (i = 0; i < size; i++){
      double w = idist->d[i].w;
      double h = idist->d[i].h;
      double ratio = w < h ? h / w : w / h;
      printf("%lf\t%d\t%d\n", ratio, w < h? 1 : 0, size);	
    }
    free(areas);
  }
  return 0;
}
