set terminal postscript eps color
set xlabel "Data"
set ylabel "Speed"
set key below

# distributions
set style line 1 pt 2 lc 1
set style line 2 pt 2 lc 2
set style line 3 pt 2 lc 3

# models
set style line 11 lt 0 lc 1
set style line 12 lt 0 lc 2
set style line 13 lt 0 lc 3

# interpolations
set style line 21 lt 2 lc 1
set style line 22 lt 2 lc 2
set style line 23 lt 2 lc 3

# fits
set style line 31 lt 1 lc 1
set style line 32 lt 1 lc 2
set style line 33 lt 1 lc 3

set output "partition.eps"
plot\
    "models.dat" using 1:2 title "model 1" with lines ls 11,\
    "models.dat" using 3:4 title "model 2" with lines ls 12,\
    "fits.dat" using 1:2 title "dynamic fit 1" with lines ls 31,\
    "fits.dat" using 1:3 title "dynamic fit 2" with lines ls 32,\
    "dist.dat" index 0 using 2:3 notitle with points ls 1,\
    "dist.dat" index 1 using 2:3 notitle with points ls 2

set output "dynamic_partition.eps"
plot\
    "models.dat" using 1:2 title "model 1" with lines ls 11,\
    "models.dat" using 3:4 title "model 2" with lines ls 12,\
    "dynamic_models.dat" using 1:2 title "dynamic model 1" with lines ls 21,\
    "dynamic_models.dat" using 3:4 title "dynamic model 2" with lines ls 22,\
    "dynamic_fits.dat" using 1:2 title "dynamic fit 1" with lines ls 31,\
    "dynamic_fits.dat" using 1:3 title "dynamic fit 2" with lines ls 32,\
    "dynamic_dist.dat" index 0 using 2:3 notitle with points ls 1,\
    "dynamic_dist.dat" index 1 using 2:3 notitle with points ls 2
