#!/bin/sh
# arg1 is search parameter: "*.fpm"
# arg2 is filename: fpm.eps
# arg3 is for error bars: 0 = none, 1 = with errorbars
if [ $# -gt 0 ] ; then
	search=$1
else
	search='*.fpm'
fi

if [ $# -gt 1 ] ; then
	output_file=$2
else
	output_file='fpm.eps'
fi
errorbars=0
if [ $# -gt 2 ] ; then
	errorbars=$3
fi


#rm -f all_in_one.plot
echo \# Gunplot script generated by plot_all_in_one.sh shell script > all_in_one.plot
echo set title \'FPM for nodes with errorbars\' >> all_in_one.plot
echo set xlabel \'Problem Size\'>> all_in_one.plot
echo set ylabel \'Speed \(flops\)\'>> all_in_one.plot
echo \#set term postscript eps enhanced color  >> all_in_one.plot
echo \#set output \'$output_file\' >> all_in_one.plot
echo set size 1,1 >> all_in_one.plot
echo	set key below >> all_in_one.plot
#echo set nokey >> all_in_one.plot
echo plot \\ >> all_in_one.plot
i=1
for file in `find -maxdepth 1 -name "$search" 2>/dev/null |sort`
do
	echo $file
	base=`basename $file`
	# Pad with spaces
	lt=`printf "%2d" $i` 

	if [ $errorbars -eq 1 ]
	then
		echo "'$file' u 1:6:((\$2*\$3/(\$2+\$4))-\$3) with errorbars lt $lt t '$base', '' u 1:3 with lines lt $lt notitle, \\" >> all_in_one.plot
	else
		/bin/echo -e "'$file' \tu 1:6 with linespoints lt $lt t '$base'\t, \\" >> all_in_one.plot
	fi
	i=$(($i+1))
done

echo 1 notitle>> all_in_one.plot
#echo pause -1 >> all_in_one.plot

gnuplot all_in_one.plot -
